/************************(i2c_SSD1306.c) ****
 *      OLED library                        *
 *      use for 0.96OLED  ,....             *
 ********************************************/

#include "myProject.h"
#include "Font_5x7.h"
//#include "i2c_SSD1306.h"

#define I2COLED_ADR     0x3C    // 0x3D
#define OLED_BF_SIZE    80

#define ROM_MAP2

//---  tHgf[^AhX)
#define F_H_ASC     0x00200     // pASCII
#define F_H_KANA    0x00800     // pJi
#define F_SYM1      0x01000     // L1(2121-217E)
#define F_SYM2      0x01BC0     // L2(2221-222E)
#define F_SYM3      0x01D80     // L3(223A-2241)
#define F_SYM4      0x01E80     // L4(224A-2250)
#define F_SYM5      0x01F60     // L5(225C-226A)
#define F_SYM6      0x02140     // L6(2272-2279)
#define F_SYM7      0x02240     // L7(227E)
#define F_NUM       0x02260     // (2330-2339)
#define F_ASC       0x023A0     // ASCiimn(2341-235A)
#define F_ASC2      0x026E0     // ASCiimn(2361-237A)
#define F_HIRA      0x02A20     // Ђ炩(2421-2473)
#define F_KATA      0x03480     // J^Ji(2521-2576)
#define F_PCDEF     0x06800
#define F_GRK1      0x1B2A0     // MVmn(2621-2638)
#define F_GRK2      0x1B5A0     // MVmn(2641-2668)
#define F_CRL1      0x1B8A0     // Lmn(2721-2741)
#define F_CRL2      0x1BCC0     // Lmn(2751-2771)
#define F_RULE      0x1C0E0     // r (2821-2840)
#define F_KAN1      0x04000     // P(3021-4F53)
#define F_KAN0      0x08000
#define F_KAN2      0x20000     // Q(5021-7426)
#define F_SYM_A     0x3A800     // SL(2121-2D7C)
//#define U_MAP       0x00C00     // usrFontMap
//#define U_FONT      0x0C000     // usrFontDat

#define NO_FONT     0x010A0      // tHgꍇ

static uint8_t CrtLn = 0;       // ݍsiy[Wjʒu

static uint8_t gBf[OLED_BF_SIZE];      // OtBbN\p

//---- OLEDŉs
uint8_t i2cOLED_LF(){
    CrtLn += 1;
    if(CrtLn > 7) CrtLn = 0;
    return CrtLn;
}

//----- Set Draw Area (for Hor/Ver Mode)-------
void i2cOLED_RangePX(uint8_t p0,uint8_t p1, uint8_t x0, uint8_t x1){
    gBf[0] = 0x00;                      // ARg[w	
    gBf[1] = 0x20; gBf[2] = 0;          // [hw
    gBf[3] = 0x21; gBf[4] = x0; gBf[5] = x1;    // ͈(x0-x1))
    gBf[6] = 0x22; gBf[7] = p0; gBf[8] = p1;    // y[W͈(p0-p1)
    I2C1_WriteNBytes(I2COLED_ADR, gBf,9);
}

//----- Cursor X,Y (for Page Mode)--------------
void i2cOLED_posPX(uint8_t pg, uint8_t cX){
    i2cOLED_RangePX(0,7,0,127);         // RangeSʂ
    gBf[0] = 0x00;                      // ARg[w
    gBf[1] = 0x20; gBf[2] = 0x02;       // Page[hw
    gBf[3] = 0xB0 + (pg & 0x07);        // pageAhXw (0xB0-B7)
    gBf[4] = cX & 0x0F;                 // sʒu(y[Wjw
    gBf[5] = 0x10 + ((cX >> 4) & 0x07);
    I2C1_WriteNBytes(I2COLED_ADR, gBf,6);
    CrtLn = pg;
}

//-------- clear LINE --------------------------
void i2cOLED_LnClr(uint8_t pg, uint8_t dt){
    uint8_t i;
    i2cOLED_posPX(pg,0);                // y[W[hňʒuw
    gBf[0]=0x40;                        // f[^Rg[w
    for(i=1;i<=65;i++) gBf[i]=dt;
    I2C1_WriteNBytes(I2COLED_ADR, gBf,65);
    I2C1_WriteNBytes(I2COLED_ADR, gBf,65);
    CrtLn = pg;
 // vRam 
    
}

//-------- clear OLED --------------------------
void i2cOLED_Clr(uint8_t p0, uint8_t p1,uint8_t dt){
	uint8_t i;
    for(i = p0; i <= p1; i++){
        i2cOLED_LnClr(i,dt);
    }
    i2cOLED_posPX(p0,0);
    CrtLn = p0;
}

//-------- OLEDɈꕶ\ ------------------------
//     Oi2cOLED_posPXňʒuw肵Ă
void i2cOLED_chr (char dat){
    char i;
    dat -= 0x20;                        // zAhXvZ
    gBf[0] = 0x40;                      // f[^Rg[w 
    for(i=0; i<5; i++) {
        gBf[i+1] = Font[dat][i];
        if(gBf[i+1] == 0xFF) break;     // Ȃ甲
    }
    gBf[i+1]=0;                         // 1hbg󂯂
    I2C1_WriteNBytes(I2COLED_ADR, gBf,i+2);     
}

//-------- display strings -------------------------
void i2cOLED_str(char *str){
    while(*str)  i2cOLED_chr(*str++);  //pointer increment
}

//------ OLEDɃp^[\
uint8_t i2cOLED_Ptn(uint8_t pg,uint8_t cx,uint8_t pn, uint8_t xn, char *ptn){
    uint8_t i; 
    i2cOLED_RangePX(pg,pg+pn-1,cx,cx+xn-1); // [hŃGAw
    gBf[0] = 0x40;                      // f[^Rg[w
    for(i = 1; i <= pn*xn; i++){
        gBf[i] = *ptn++;
    }
    I2C1_WriteNBytes(I2COLED_ADR, gBf, pn*xn+1);
    return cx+xn;
}

//-------- OLED initialize  ------------------
void i2cOLED_init(void){
    __delay_ms(20);                     // 20ms wait
    uint8_t Cmds[]={
                0x00,                   // ARg[w
                0xA8,0x3F,              // C 64s
                0xD3,0x00,              // \ItZbg
                0x40,                   // \JnC0(6rbgj
//                0xA0,                 // E] 0xA0:/0xA1:
//                0xC0,                 // ㉺] 0xC0:/0xC8:
//                0xDA,0x02,            // \[hAlternative
//                0x81,0x7F,            // RgXg= 127(/0-255)
//                0xA4,                 // `̋H
//                0xA6,                 // ] A6:/A7F]
//                0xD5,0x80,            // NbN䁁128
//                0x20,0x00,            // AhX[hhorizontal
                0x8D,0x14,              // `[W|vݒ(K{)
                0xAF                    // \Jn
                };
    I2C1_WriteNBytes(I2COLED_ADR, Cmds,9);  //MoCgɍ킹
}

uint32_t HfntAdr(uint8_t chCode){
  #ifdef ROM_MAP2
        return (chCode - 0x20) * 16 + F_H_ASC;    
  #else
    if((chCode >= 0x20) & (chCode < 0x7F)){
        return (chCode - 0x20) * 16 + F_H_ASC;
    }else if((chCode > 0xA0) & (chCode <= 0xDF)){
        return  (chCode - 0xA0) * 16 + F_H_KANA;        
    }
  #endif
    return 0;
}

//---- p(8x16)\ixposʒuԂj-----
uint8_t i2cOLED_HchrX(uint8_t xpos, uint8_t ypos, uint8_t chCode){
    uint32_t adr;
    char  ptn[16];
    adr = HfntAdr(chCode);
    if(adr > 0){
        I2C_Mem_NRead(adr,(uint8_t *)ptn,16);
        xpos = i2cOLED_Ptn(ypos,xpos,2,8,ptn);
    }
    return xpos;
}

//-------- oCgPʂŔp\ixposʒuԂj-----
uint8_t i2cOLED_HstrX(uint8_t xpos, uint8_t ypos, char *str){
    while(*str)  xpos = i2cOLED_HchrX(xpos, ypos, *str++);
    return xpos;                                //\ʒuԂ
}

//---- VtgJIS[JISϊ
uint16_t SJis2Jis(uint16_t sCd){
    uint8_t hi,lo;
    hi = sCd >> 8;
    lo = (uint8_t)sCd;
    if(hi <= 0x9F){
        if(lo < 0x9F)   hi = hi * 2 - 0xE1;
        else            hi = hi * 2 - 0xE0;
    }else{
        if(lo < 0x9F)   hi = (hi - 0xB0) * 2 - 1;
        else            hi = (hi - 0xB0) * 2;
    }
    if(lo < 0x7F)       lo = lo - 0x1F;
    else{
        if(lo < 0x9F)   lo = lo - 0x20;
        else            lo = lo - 0x7E;
    }
    return (hi * 256 + lo);
}

//--- Sp(jtHgAhX擾)
uint32_t KfntAdr(uint16_t kCode){
    uint8_t msb, lsb;
    uint32_t lmsb, llsb;
    msb = kCode >> 8;
    lsb = (uint8_t)kCode & 0x000FF;
    lmsb = (uint32_t)msb;
    llsb = (uint32_t)lsb;
#ifdef ROM_MAP2
    if(msb>=0x21 & msb<=0x28){                   // SpLEpEȕ
        if(lsb>=0x21 & lsb<=0x7E) return F_SYM1 + (lmsb-0x21)*3008+(llsb-0x21)*32;
        else                      return NO_FONT;
    }else if(msb==0x2d){
        if(lsb>=0x21 & lsb<=0x7E) return F_PCDEF + (lmsb-0x2d)*3008+(llsb-0x21)*32;
        else                      return NO_FONT;
  
  #else
    if(msb>=0x21 & msb<0x30){
        if(msb==0x21){                        // L1
            if(lsb>=0x21 & lsb<=0x7E) return F_SYM1+(lsb-0x21)*32;
            else                        return NO_FONT;
        }else if(msb==0x22){                // L2
            if(lsb>=0x21 & lsb<=0x2E) return F_SYM2 + (lsb-0x21)*32;
            else                      return NO_FONT;
        }else if(msb==0x23){                // ASCII
            if(lsb>=0x30 & lsb<=0x39) return F_NUM + (lsb-0x30)*32;
            if(lsb>=0x41 & lsb<=0x5A) return F_ASC + (lsb-0x41)*32;
            if(lsb>=0x61 & lsb<=0x7A) return F_ASC2 + (lsb-0x61)*32;
            else                      return NO_FONT;;
        }else if(msb==0x24){                // Ђ炩
            if(lsb>=0x21 & lsb<=0x73) return F_HIRA + (lsb-0x21)*32;
            else                      return NO_FONT;
        }else if(msb==0x25){                // J^Ji
            if(lsb>=0x21 & lsb<=0x76) return F_KATA + (lsb-0x21)*32;
            else                      return NO_FONT;
        }else if(msb==0x26){                // MV
            if(lsb>=0x21 & lsb<=0x38) return F_GRK1 + (lsb-0x21)*32;
            if(lsb>=0x41 & lsb<=0x58) return F_GRK2 + (lsb-0x41)*32;
            else                      return NO_FONT;;
        }else if(msb==0x27){                // L
            if(lsb>=0x21 & lsb<=0x41) return F_CRL1 + (lsb-0x21)*32;
            if(lsb>=0x51 & lsb<=0x71) return F_CRL2 + (lsb-0x51)*32;
            else                      return NO_FONT;;
        }else if(msb==0x28){                // r
            if(lsb>=0x21 & lsb<=0x40) return F_RULE + (lsb-0x21)*32;
            else                      return NO_FONT;
        }
        
#endif
    }else if(msb<0x50){                     // iPj
        if(lsb>=0x21 & lsb<=0x7E) return F_KAN0 + (lmsb-0x30)*3008+(llsb-0x21)*32;
        else                      return NO_FONT;
    }else if(msb<0x75){                     // iQjGT20L16J1Ygp̂
        if(lsb>=0x21 & lsb<=0x7E) return F_KAN2 + (lmsb-0x50)*3008+(llsb-0x21)*32;
        else                      return NO_FONT;
    }
	return NO_FONT;
}

//---- oCgPʂőSp(j\
uint8_t i2cOLED_ZchrX(uint8_t xpos, uint8_t ypos, uint16_t kCd,uint8_t ed){
    uint32_t adr;
    uint16_t kk;
    uint8_t h,l;
    char ptn[32];
//    char sBf[20];
    if(ed & 0x01){
        h = (uint8_t)(kCd>>8);
        l = (uint8_t)kCd;
        kCd = l*256+h;
    }
    if(ed < 2)  kk = SJis2Jis(kCd);
    else        kk = kCd;
    
//    sPrt_AdrDt(sBf,(uint32_t)kk, (uint8_t)kCd, '>'); puts(sBf);      
    adr = KfntAdr(kk);

    I2C_Mem_NRead(adr,(uint8_t *)ptn,32);
 //    sPrt_AdrDt(sBf,adr, ptn[0], '>'); puts(sBf);  
    if(adr)	return i2cOLED_Ptn(ypos,xpos,2,16,ptn);
    return xpos;
}

//---- oCgPʈʒuőSp(j\
uint8_t i2cOLED_ZstrX(uint8_t xpos, uint8_t ypos, char *str,uint8_t ed){
    uint16_t cd, *kjP;
    kjP = (uint16_t *)str;
    while(*kjP & 0xFF){
        xpos = i2cOLED_ZchrX(xpos,ypos,*kjP,ed);
        kjP++;
    }
    return xpos;
}		
/********  End of File ******/
